;
; Simple Disk controller for Intelligent drive - 'SDI88'
;
; Copyright (C) 2020-2021 ohD
;
; [ IPL for MS-DOS ]
;

		IDEAL
		P186
		MODEL	TINY
		CODESEG

		ORG	0000H

;
; IPLGg
; 1FC0:0000փ[h
;
ENTRY:
	IFDEF	TYPE_2HD
; 60h (bra.s)
		PUSHA
; 3Ch + 90h
		CMP	AL,90H
; JMP(OEM NAME3oCg)
		JMP	START

; OEM NAME(c)
		DB	'SDI88'
	ELSE
; JMP(2oCg)
		JMP	START
; NOP(1oCg)
		NOP
; OEM NAME(8oCg)
		DB	'SDI88   '
	ENDIF

	IFDEF	TYPE_2HD

; ZN^̃oCg
		DW	0400h

; 1NX^̃ZN^
		DB	01h

; \ZN^
		DW	0001h

; FAT
		DB	02h

; [gfBNg̃Gg
		DW	00C0h

; {[̑ZN^
		DW	04D0h

; fBAEfBXNv^
		DB	0FEh

; FAT̃ZN^
		DW	0002h

; gbÑZN^
		DW	0008h

; wbh
		DW	0002h

; BZN^
		DD	00000000h

; {[̑ZN^(32bit)
		DD	00000000h

; hCuԍ(80H:NhCu)
		DB	80h

; \̈
		DB	00h

; gu[gR[hʃR[h
		DB	29h

; {[VAԍ
		DB	00h,00h,00h,00h

; {[x
		DB	'NO NAME    '

; t@CVXe
		DB	'FAT12   '

;
; X680x0IPLf[^
;
	IFNDEF	DEBUG

	DB  4Fh,0F8h, 20h, 00h, 47h,0FAh, 01h, 10h, 49h,0FAh, 01h, 90h, 43h
	DB 0FAh, 01h, 0Ch, 70h, 21h, 4Eh, 4Fh, 70h, 8Eh, 4Eh, 4Fh, 7Eh, 70h
	DB 0E1h, 48h, 8Eh, 40h, 24h, 3Ch, 03h, 00h, 00h, 06h, 26h, 13h, 22h
	DB  4Ch, 61h, 00h, 00h, 9Ah, 22h, 4Ch, 72h, 1Fh, 20h, 49h, 45h,0FAh
	DB  00h,0E8h, 70h, 0Ah, 00h, 10h, 00h, 20h,0B1h, 0Ah, 56h,0C8h,0FFh
	DB 0F8h, 67h, 10h, 43h,0E9h, 00h, 20h, 51h,0C9h,0FFh,0E6h, 45h,0FAh
	DB  00h,0DAh, 60h, 00h, 00h, 84h, 74h, 00h, 34h, 29h, 00h, 1Ah,0E1h
	DB  5Ah, 06h, 42h, 00h, 09h, 36h, 02h,0E6h, 4Ah, 02h, 43h, 00h, 07h
	DB  52h, 83h,0E2h, 0Ah, 64h, 04h, 00h, 43h, 01h, 00h, 00h, 42h, 03h
	DB  00h, 48h, 42h, 34h, 03h, 26h, 13h, 22h, 4Ch, 61h, 44h, 45h,0F8h
	DB  68h, 00h, 22h, 4Ch, 0Ch, 59h, 48h, 55h, 67h, 06h, 45h,0FAh, 00h
	DB 0CCh, 60h, 44h, 54h, 89h,0B5h,0D9h, 67h, 06h, 45h,0FAh, 00h,0DCh
	DB  60h, 38h, 2Fh, 19h, 20h, 59h,0D1h,0D9h, 2Fh, 08h, 2Fh, 11h, 43h
	DB 0F8h, 67h,0C0h, 76h, 40h,0D6h, 88h, 61h, 12h, 22h, 1Fh, 24h, 1Fh
	DB  22h, 5Fh,0D5h,0C2h, 53h, 81h, 65h, 04h, 42h, 1Ah, 60h,0F8h, 4Eh
	DB 0D1h, 32h, 07h, 70h, 46h, 4Eh, 4Fh, 08h, 00h, 00h, 1Eh, 66h, 02h
	DB  4Eh, 75h, 45h,0FAh, 00h, 70h, 72h, 0Fh, 70h, 22h, 4Eh, 4Fh, 72h
	DB  19h, 74h, 0Ch, 70h, 23h, 4Eh, 4Fh, 61h, 22h, 72h, 19h, 74h, 0Dh
	DB  70h, 23h, 4Eh, 4Fh, 61h, 18h, 22h, 4Ah, 4Ch, 99h, 00h, 06h, 70h
	DB  23h, 4Eh, 4Fh, 70h, 21h, 4Eh, 4Fh, 32h, 07h, 70h, 4Fh, 4Eh, 4Fh
	DB  70h,0FEh, 4Eh, 4Fh, 76h, 2Ch, 72h, 20h, 70h, 20h, 4Eh, 4Fh, 51h
	DB 0CBh,0FFh,0FAh, 4Eh, 75h, 00h, 00h, 04h, 00h, 1Ah, 00h, 68h, 75h
	DB  6Dh, 61h, 6Eh, 20h, 20h, 20h, 73h, 79h, 73h, 00h, 00h, 25h, 00h
	DB  0Dh, 48h, 55h, 4Dh, 41h, 4Eh, 2Eh, 53h, 59h, 53h, 20h, 69h, 73h
	DB  20h, 6Eh, 6Fh, 74h, 20h, 66h, 6Fh, 75h, 6Eh, 64h, 21h, 00h, 00h
	DB  28h, 00h, 0Dh, 44h, 69h, 73h, 6Bh, 20h, 72h, 65h, 61h, 64h, 20h
	DB  65h, 72h, 72h, 6Fh, 72h, 21h, 00h, 00h, 00h, 25h, 00h, 0Dh, 48h
	DB  55h, 4Dh, 41h, 4Eh, 2Eh, 53h, 59h, 53h, 20h, 69h, 73h, 20h, 63h
	DB  6Fh, 72h, 72h, 75h, 70h, 74h, 65h, 64h, 21h, 00h, 00h, 21h, 00h
	DB  0Dh, 49h, 6Ch, 6Ch, 65h, 67h, 61h, 6Ch, 20h, 61h, 64h, 64h, 72h
	DB  65h, 73h, 73h, 20h, 77h, 69h, 74h, 68h, 20h, 48h, 55h, 4Dh, 41h
	DB  4Eh, 2Eh, 53h, 59h, 53h, 21h, 00h

	ENDIF

	ELSE

; ZN^̃oCg
		DW	0200h

; 1NX^̃ZN^
		DB	02h

; \ZN^
		DW	0001h

; FAT
		DB	02h

; [gfBNg̃Gg
		DW	0070h

; {[̑ZN^
		DW	05A0h

; fBAEfBXNv^
		DB	0F9h

; FAT̃ZN^
		DW	0003h

; gbÑZN^
		DW	0009h

; wbh
		DW	0002h

; BZN^
		DD	00000000h

; {[̑ZN^(32bit)
		DD	00000000h

; hCuԍ(80H:NhCu)
		DB	80h

; \̈
		DB	00h

; gu[gR[hʃR[h
		DB	29h

; {[VAԍ
		DB	00h,00h,00h,00h

; {[x
		DB	'NO NAME    '

; t@CVXe
		DB	'FAT12   '

	ENDIF

;
; IPLJn
;
START:
		CLD
; DS=CS
		MOV	AX,CS
		MOV	DS,AX
; ES=0000h
		XOR	AX,AX
		MOV	ES,AX
; SS:SP=0000:028Ah
		MOV	SS,AX
		MOV	SP,028Ah
; NDA/UA]
		MOV	AL,[ES:0584h]
		MOV	[BOOT_DAUA],AL

; fobOp
	IFDEF	DEBUG
		CALL	DEBUG_INIT
	ENDIF

;
; [gfBNgǂݍ
;
PROC	ROOT_DIR
; [gfBNg̍ŏ̃ZN^ǂݍ
	IFDEF	TYPE_2HD
; C=00h/H=00h/R=06h/N=03h(0400h)
		MOV	BX,0400h
		MOV	CX,0300h
		MOV	DX,0006h
	ELSE
; C=00h/H=00h/R=08h/N=02h(0200h)
		MOV	BX,0200h
		MOV	CX,BX
		MOV	DX,0008h
	ENDIF
; ǂݍ݃obt@0000h:0600h
		MOV	BP,0600h
		CALL	DISK_READ
; t@C
	IFDEF	TYPE_2HD
		MOV	CX,32
	ELSE
		MOV	CX,16
	ENDIF
; Xbg[v
@@SLOT:
		PUSH	CX
		MOV	SI,offset FILE_NAME
		MOV	DI,BP
		MOV	CX,11
		REPZ	CMPSB
		JZ	@@FOUND
; ̃Xbg
		ADD	BP,0020h
		POP	CX
		LOOP	@@SLOT
; IO.SYSȂ
		MOV	SI,offset NOTFOUND_MSG
		JMP	IPL_ERROR
; 擪NX^擾
@@FOUND:
		POP	CX
		MOV	AX,[ES:BP+001Ah]
	IFDEF	TYPE_2HD
; NX^0ɑΉ΃ZN^ԍZ
		ADD	AX,0009h
; CX=gbN(΃ZN^ԍ/8)
		MOV	CX,AX
		SHR	CX,3
; DX=ZN^(΃ZN^ԍ%8 + 1)
		AND	AX,0007h
		INC	AX
		MOV	DX,AX
; N=3
		MOV	CH,03h
	ELSE
; NX^ԍ2{(1NX^2ZN^)
		ADD	AX,AX
; NX^0ɑΉ΃ZN^ԍZ
		ADD	AX,000Ah
; gbN9ZN^
		MOV	CL,09H
		DIV	CL
; AL=A]=AH
		MOV	CL,AL
; DL=ZN^(΃ZN^ԍ%9 + 1)
		XOR	DH,DH
		MOV	DL,AH
		INC	DL
; N=2
		MOV	CH,02h
	ENDIF
; gbNV_Ewbh֕ϊ
		SHR	CL,1
		RCL	DH,1
ENDP

;
; IO.SYSMSDOS.SYSǂݍ
; ǂݍ݊JnAhX 0060h:0000h=0000h:0600h
; 2HD0400hoE_œ]֌WA0000h:0800hƂ
; ǂݍ݃TCY 1F000h
; EINT1Bh AH=06h̓VOgbN[hŎgp
; EDMA̐A64KBE܂ǂݍ݂͍sȂ
;
PROC	READ_MAIN
; ǂݍ݃TCY(8bitEVtgl)
		MOV	SI,01F0h
; ]obt@(8bitEVtgl)
	IFDEF	TYPE_2HD
		MOV	DI,0008h
	ELSE
		MOV	DI,0006h
	ENDIF
; ǂݍ݃AhX(ESDIɊÂĕύX̂ŁABP͏0000h)
		MOV	BP,0000h
; CH=OX(N)ACL=V_(C)ADH=wbh(H)ADL=ZN^(R)
@@LOOP:
; ̃gbNœǂݍ݉\ȓǂݍ݃TCYZo(8bitEVtgl)
	IFDEF	TYPE_2HD
		MOV	BX,0009h
		SUB	BL,DL
		SHL	BL,2
	ELSE
		MOV	BX,000Ah
		SUB	BL,DL
		ADD	BL,BL
	ENDIF
; SI < BXł΁ABX=SIƂ
		CMP	SI,BX
		JNC	@@BOUNDCHK
		MOV	BX,SI
; DIƁADI+BXrA0100hANDlĂ邩`FbN
@@BOUNDCHK:
		MOV	AX,DI
		ADD	AX,BX
		XOR	AX,DI
		AND	AX,0100H
		JZ	@@BOUNDOK
; 64KBoE_ÊׂŁA␳
		MOV	BX,DI
		AND	BX,0FF00h
		ADD	BX,0100h
		SUB	BX,DI
; 64KBoE_EׂȂA܂͕␳ς
@@BOUNDOK:
; ES=DI<<4
		MOV	AX,DI
		SHL	AX,4
		MOV	ES,AX

	IFDEF	DEBUG
		CALL	DEBUG_REG
	ENDIF

; SI,DIɏĂ
		SUB	SI,BX
		ADD	DI,BX
; ǂݍ(BP͏0000h)
		SHL	BX,8
		CALL	DISK_READ
; BXtZăZN^(R)Z
	IFDEF	TYPE_2HD
		SHR	BX,10
		ADD	DL,BL
; ZR08hȉł΂̃gbNp
		CMP	DL,09h
		JC	@@CONT
	ELSE
		SHR	BX,9
		ADD	DL,BL
; ZR09hȉł΂̃gbNp
		CMP	DL,0Ah
		JC	@@CONT
	ENDIF
; ZN^ԍ
		MOV	DL,01h
; ̃wbh
		XOR	DH,01h
		JNZ	@@CONT
; ̃V_
		INC	CL
; I`FbN
@@CONT:
		OR	SI,SI
		JNZ	@@LOOP
ENDP

;
; IO.SYSGgփWv
;
PROC	GO_SYS
	IFDEF	TYPE_2HD
; 0080h:0000h0060h:0000h64KB]
		MOV	AX,0080h
		MOV	DS,AX
		MOV	AX,0060h
		MOV	ES,AX
		XOR	SI,SI
		XOR	DI,DI
		MOV	CX,8000h
		REP	MOVSW
; 1080h:0000h1060h:0000hF000h]
		MOV	AX,1080h
		MOV	DS,AX
		MOV	AX,1060h
		MOV	ES,AX
		XOR	SI,SI
		XOR	DI,DI
		MOV	CX,7800h
		REP	MOVSW
	ENDIF
; DS=ES=0000h
		XOR	AX,AX
		MOV	DS,AX
		MOV	ES,AX
; Wv
		JMP	far 0060h:0000h
ENDP

;
; fBXNǂݍ
;
; PARAM.: AL	DA/UA
; PARAM.: BX	]oCg
; PARAM.: CH	OX(N)
; PARAM.: CL	V_(C)
; PARAM.: DH	wbh(H)
; PARAM.: DL	ZN^(R)
; PARAM.: ES:BP	ǂݍݐAhX
;
PROC	DISK_READ
; AH=06h(VOgbN/MFM/SEEK/gC)
		MOV	AH,56H
; AL=NDA/UA
		MOV	AL,[BOOT_DAUA]
; INT 1Bh
		INT	1BH
		JC	@@ERROR
		RET
; ǂݍ݃G[
@@ERROR:
		MOV	SI,offset READERR_MSG
		JMP	IPL_ERROR
ENDP

;
; IPLG[
;
; PARAM.: DS:SI	G[bZ[W
; PARAM.: ES	0000H
;
PROC	IPL_ERROR
; CRT[hݒ
		MOV	AX,0A00h
		INT	18h
; eLXgON
		MOV	AH,0Ch
		INT	18h
; J[\OFF
		MOV	AH,12H
		INT	18h
; m[}[heLXgVRAMZOg
		MOV	AH,0A0H
; nC]tO
		TEST	[byte ES:0501h],08h
		JZ	@@SEGMENT
; nC][heLXgVRAMZOg
		MOV	AH,0E0H
@@SEGMENT:
		MOV	ES,AX
; eLXgVRAMZOg̃ItZbg͌Œl
		MOV	DI,0140H
; bZ[W[v
@@LOOP:
		LODSB
		OR	AL,AL
		JZ	@@EXIT
		STOSB
; pȂ̂œ]1oCgXLbv
		INC	DI
		JMP	@@LOOP
; BEEPo
@@EXIT:
		MOV	AL,06h
		OUT	37h,AL
; [v
@@INFINITE:
		JMP	@@INFINITE
ENDP

;
; IO.SYS
;
FILE_NAME	DB	'IO      SYS'

;
; t@CȂ
;
NOTFOUND_MSG	DB	'No system files!',0

;
; ǂݍ݃G[
;
READERR_MSG	DB	'Disk read error!',0

;
; NDA/UA
;
BOOT_DAUA	DB	00h

	IFDEF	DEBUG

;
; WX^\ 
;
PROC	DEBUG_INIT
; CRT[hݒ
		MOV	AX,0A00h
		INT	18h
; eLXgON
		MOV	AH,0Ch
		INT	18h
; J[\OFF
		MOV	AH,12H
		INT	18h
		RET
ENDP

;
; WX^\
;
PROC	DEBUG_REG
; WX^(AX,CX,DX,BX,SP,BP,SI,DI)
		PUSHA
; ZOg
		PUSH	DS
		PUSH	ES
; eLXgVRAM
		MOV	AX,0A000H
		MOV	DS,AX
		MOV	ES,AX
; AX=BX=fobOs
		MOV	AX,[CS:DEBUG_LINE]
		MOV	BX,AX
; fobOs24`FbN
		CMP	BX,24
		JNZ	@@MUL
; XN[
		STD
		MOV	SI,3840
		MOV	DI,4000
		MOV	CX,1920
		REP	MOVSW
		CLD
		MOV	DI,3840
		JMP	@@PREPARE
; DI=fobOs~160
@@MUL:
		IMUL	AX,160
		MOV	DI,AX
; fobOsi߂
		INC	BX
		MOV	[CS:DEBUG_LINE],BX
; 
@@PREPARE:
		MOV	AX,CS
		MOV	DS,AX
		MOV	BP,SP
; AX
		MOV	SI,offset AX_MSG
		MOV	BX,[SS:BP+18]
		CALL	DEBUG_SUB
; BX
		MOV	SI,offset BX_MSG
		MOV	BX,[SS:BP+12]
		CALL	DEBUG_SUB
; CX
		MOV	SI,offset CX_MSG
		MOV	BX,[SS:BP+16]
		CALL	DEBUG_SUB
; DX
		MOV	SI,offset DX_MSG
		MOV	BX,[SS:BP+14]
		CALL	DEBUG_SUB
; SI
		MOV	SI,offset SI_MSG
		MOV	BX,[SS:BP+6]
		CALL	DEBUG_SUB
; DI
		MOV	SI,offset DI_MSG
		MOV	BX,[SS:BP+4]
		CALL	DEBUG_SUB
; BP
		MOV	SI,offset BP_MSG
		MOV	BX,[SS:BP+8]
		CALL	DEBUG_SUB
; DS
		MOV	SI,offset DS_MSG
		MOV	BX,[SS:BP+2]
		CALL	DEBUG_SUB
; ES
		MOV	SI,offset ES_MSG
		MOV	BX,[SS:BP+0]
		CALL	DEBUG_SUB
; ZOg
		POP	ES
		POP	DS
; WX^(DI,SI,BP,SP,BX,DX,CX,AX)
		POPA
		RET
ENDP

;
; WX^\Tu
;
; PARAM.: SI	WX^(2)
; PARAM.: ES:DI	eLXgVRAMAhX
; PARAM.: BX	WX^l
; RESULT: DI	+14
;
PROC	DEBUG_SUB
; Xy[X
		MOV	AL,20h
		STOSB
		INC	DI
; WX^
		LODSB
		STOSB
		INC	DI
		LODSB
		STOSB
		INC	DI
; ':'
		MOV	AL,':'
		STOSB
		INC	DI
; WX^
		MOV	AL,BH
		CALL	DEBUG_8BIT
; WX^
		MOV	AL,BL
; DEBUG_8BIT
ENDP

;
; WX^\(8BIT)
;
; PARAM.: AL	8BITl
;
PROC	DEBUG_8BIT
		MOV	AH,AL
		SHR	AL,4
		CALL	DEBUG_4BIT
		MOV	AL,AH
; DEBUG_4BIT
ENDP

;
; WX^\(4BIT)
;
; PARAM.: AL	4BITl
;
PROC	DEBUG_4BIT
		AND	AL,0Fh
		ADD	AL,30h
		CMP	AL,3Ah
		JC	@@COMMON
; A-F
		ADD	AL,07h
; 0-9,A-F
@@COMMON:
		STOSB
		INC	DI
		RET
ENDP

;
; fobO
;
PROC	DEBUG_INF
		JMP	DEBUG_INF
ENDP

;
; fobObZ[W
;
AX_MSG		DB	'AX'
BX_MSG		DB	'BX'
CX_MSG		DB	'CX'
DX_MSG		DB	'DX'
SI_MSG		DB	'SI'
DI_MSG		DB	'DI'
BP_MSG		DB	'BP'
DS_MSG		DB	'DS'
ES_MSG		DB	'ES'

;
; fobOs
;
DEBUG_LINE	DW	00h

	ENDIF

;
; vOI
;
		END	ENTRY
