*
* Simple Disk controller for Intelligent drive - 'SDI88'
*
* Copyright (C) 2020-2021 ohD
*
* [ IPL for Human68k ]
*
		.text
		.even

		.include iocscall.mac

*
* IPLJn
* $2000ɔzuꂽbra.s߂ŃWvĂ
*
start:
* X^bN|C^
		lea.l	$2000.w,a7
* |C^(ZN^TCYуfBXNobt@)
		lea.l	sector_size(pc),a3
		lea.l	disk_buffer(pc),a4
* bZ[W\
		lea.l	init_msg(pc),a1
		IOCS	_B_PRINT
* IOCSN擾Ad7.wPDA쐬
		IOCS	_BOOTINF
		moveq.l	#$70,d7
		lsl.w	#8,d0
		or.w	d0,d7
* [gfBNg̍ŏ̃ZN^ǂݍ
		move.l	#$03000006,d2
		move.l	(a3),d3
		movea.l	a4,a1
		bsr	disk_read

*
* [gfBNg̍ŏ32Gg
* 'HUMAN.SYS'
*
find:
		movea.l	a4,a1
		moveq.l	#32-1,d1
* 32fBNgXbg̃[v
find1:
		movea.l	a1,a0
		lea.l	human_sys(pc),a2
		moveq.l	#11-1,d0
* 12̃[v
find2:
		ori.b	#$20,(a0)
		cmp.b	(a2)+,(a0)+
		dbne.w	d0,find2
		beq	read_first
* ̃fBNgXbg
		lea.l	$20(a1),a1
		dbra.w	d1,find1
		lea.l	notfound_msg(pc),a2
		bra	error

*
* 'HUMAN.SYS'̍ŏ̃ZN^ǂݍ
*
* param: a1.l	fBNgXbg
*
read_first:
* d2.w=NX^
		moveq.l	#$00,d2
		move.w	$001a(a1),d2
* GfBAϊ(rbOGfBA)
		rol.w	#8,d2
* NX^0ɑΉ΃ZN^No.(0IW)𓾂
		addi.w	#$0009,d2
* d2d3փRs[
		move.w	d2,d3
* d2 = d2 / 8
		lsr.w	#3,d2
* d3 = (d3 % 8) + 1
		andi.w	#$0007,d3
		addq.l	#1,d3
* d2 = N | C | H | R
		lsr.b	#1,d2
		bcc	read_first1
* H=1
		ori.w	#$0100,d3
* N=3
read_first1:
		ori.w	#$0300,d2
		swap.w	d2
		move.w	d3,d2
* ŏ̃ZN^ǂݍ
		move.l	(a3),d3
		movea.l	a4,a1
		bsr	disk_read

*
* 'HUMAN.SYS'̃wb_p[^ǂݍ
*
get_header:
		lea.l	$6800.w,a2
		movea.l	a4,a1
* 'HU'Ɣr
		cmpi.w	#$4855,(a1)+
		beq	get_header1
* HUMAN.SYSjĂ
		lea.l	badfile_msg(pc),a2
		bra	error
get_header1:
		addq.l	#2,a1
* AhX $000068000 Ɣr
		cmpa.l	(a1)+,a2
		beq	get_header2
* HUMAN.SYS̃AhXُ
		lea.l	illaddr_msg(pc),a2
		bra	error
* AhXƃTCYX^bNɐς
get_header2:
		move.l	(a1)+,-(a7)
		movea.l	(a1)+,a0
		adda.l	(a1)+,a0
		move.l	a0,-(a7)
		move.l	(a1),-(a7)

*
* 'HUMAN.SYS'̖{̂ǂݍ
*
read_main:
		lea.l	$67c0.w,a1
		moveq.l	#$40,d3
		add.l	a0,d3
		bsr	disk_read
		move.l	(a7)+,d1
		move.l	(a7)+,d2
		movea.l	(a7)+,a1

*
* bss̈[NA
* (ʏ͕KvȂ)
*
clear_bss:
		adda.l	d2,a2
clear_bss1:
		subq.l	#1,d1
		bcs	jump_to_human
		clr.b	(a2)+
		bra	clear_bss1

*
* 'HUMAN.SYS'̃Gg
* $00006800փWv
*
jump_to_human:
		jmp	(a1)

*
* fBXNǂݍ
*
disk_read:
		move.w	d7,d1
		IOCS	_B_READ
* ST0bit6:IC(Interrupt Code)ZbgĂΓǂݍ݃G[Ƃ
		btst.l	#30,d0
		bne	disk_read1
		rts
disk_read1:
		lea.l	readerr_msg(pc),a2
* G[

*
* G[
*
* param.: a2.l	G[bZ[W
*
error:
* eLXgJ[w
		moveq.l	#$0f,d1
		IOCS	_B_COLOR
* sNA1
		moveq.l	#$19,d1
		moveq.l	#$0c,d2
		IOCS	_B_LOCATE
		bsr	error_sub
* sNA2
		moveq.l	#$19,d1
		moveq.l	#$0d,d2
		IOCS	_B_LOCATE
		bsr	error_sub
* J[\ʒuݒ
		movea.l	a2,a1
		movem.w	(a1)+,d1-d2
		IOCS	_B_LOCATE
* G[bZ[W\
		IOCS	_B_PRINT
* fBXNCWFNg
		move.w	d7,d1
		IOCS	_B_EJECT
* IPLG[(VXe\IOCS)
		IOCS	_IPLERR

*
* G[Tu
* (1sNA)
*
error_sub:
		moveq.l	#45-1,d3
		moveq.l	#$20,d1
* Xy[X45\
error_sub1:
		IOCS	_B_PUTC
		dbra.w	d3,error_sub1
		rts

*
* 萔(ZN^TCY)
*
sector_size:
		.dc.l	$00000400

*
* bZ[W
*
init_msg:
		.dc.b	$1a,$00

*
* HUMAN.SYS
*
human_sys:
		.dc.b	'human   sys',0

		.even

*
* G[bZ[W
* HUMAN.SYSȂ
*
notfound_msg:
		.dc.w	$0025
		.dc.w	$000d
		.dc.b	'HUMAN.SYS is not found!',0

		.even

*
* G[bZ[W
* fBXNǂݍ݂Ɏs
*
readerr_msg:
		.dc.w	$0028
		.dc.w	$000d
		.dc.b	'Disk read error!',0

		.even

*
* G[bZ[W
* 'HUMAN.SYS'̃t@Cwb_ُ
*
badfile_msg:
		.dc.w	$0025
		.dc.w	$000d
		.dc.b	'HUMAN.SYS is corrupted!',0

		.even

*
* G[bZ[W
* 'HUMAN.SYS'̃[hAhXُ
*
illaddr_msg:
		.dc.w	$0021
		.dc.w	$000d
		.dc.b	'Illegal address with HUMAN.SYS!',0

*
* fBXNobt@
* [gfBNgyэŏ̃ZN^̓ǂݍ݂Ŏg
*
disk_buffer:

*
* vOI
*
		.end	start
